# Code for MMD-Regularized Unbalanced Optimal Transport (13260)

You may install our ot_mmd package by cloning the repository and running `pip install .`
Other libraries can be installed via `pip install -r requirements.txt`. Please separately install PyTorch & Torchvision as mentioned in requirements.txt.

### Algorithms
  - [Code for solving MMD-OT using Accelerated PGD.](./ot_mmd/mmdot.py)
      - [Code for computing a batch of MMD-OT problems parallelly.](./ot_mmd/b_mmdot.py)
  - [Code for solving the MMD-OT barycenter problem using Accelerated PGD.](./ot_mmd/barycenter.py)
### Basic Examples
  - [OT plan between Gaussians.](./examples/synthetic/OTplan.ipynb)
  - [Barycenter between Gaussians.](./examples/synthetic/barycenter_with_imq.ipynb)
### [More Examples](./examples)

## Datasets

